import math
import numpy as np
from PyRexExt import REX

def init():
	global run
	global x1_last
	global x2_last
	global x3_last
	global x4_last
	global u1_last
	global u1_cur
	global x1_0
	global x2_0
	global x3_0
	global x4_0
	u1_cur = REX.u0.v
	x1_0  = REX.u1.v
	x2_0  = REX.u2.v
	x3_0  = REX.u3.v
	x4_0  = REX.u4.v
	run = 1
	return 0

def ex1derivs(x,uu):
	dx1 = -x[0]+x[1]+ REX.u5.v
	dx2 = -x[1]+x[2]+ REX.u6.v
	dx3 = -x[2]+x[3]+ REX.u7.v
	dx4 = -x[3]+uu  + REX.u8.v
	dx=np.array([dx1,dx2,dx3,dx4])
	return dx 

def rungeKutta(xk,u1_last,u1_cur):
	h=0.04 # task period (tick * ntick = 0.04 * 1 = 0.04 s
	u1mk=1/2*(u1_cur+u1_last)
	k1  =  ex1derivs(xk,u1_last)
	k2  =  ex1derivs(xk+h*k1/2,u1mk)
	k3  =  ex1derivs(xk+h*k2/2,u1mk)
	k4  =  ex1derivs(xk+h*k3,u1_cur)
	xk11 =  xk[0] + h/6*(k1[0]+2*k2[0]+2*k3[0]+k4[0])	
	xk12 =  xk[1] + h/6*(k1[1]+2*k2[1]+2*k3[1]+k4[1])
	xk13 =  xk[2] + h/6*(k1[2]+2*k2[2]+2*k3[2]+k4[2])
	xk14 =  xk[3] + h/6*(k1[3]+2*k2[3]+2*k3[3]+k4[3])
	xk1=np.array([xk11,xk12,xk13,xk14])
	return xk1
	
def main():
	global run
	global x1_last
	global x2_last
	global x3_last
	global x4_last
	global u1_last
	global u1_cur
	global x1_0
	global x2_0
	global x3_0
	global x4_0
	global x1_out
	global x2_out
	global x3_out
	global x4_out
	
	if run == 1:
		x1_out = x1_0
		x2_out = x2_0
		x3_out = x3_0
		x4_out = x4_0
		x1_last = x1_0
		x2_last = x2_0
		x3_last = x3_0
		x4_last = x4_0
		u1_last = u1_cur
		run = 2; 
	else:
		u1_cur = REX.u0.v
		xout =rungeKutta(np.array([x1_last,x2_last,x3_last,x4_last]),u1_last,u1_cur)
		x1_out = xout[0]
		x2_out = xout[1]
		x3_out = xout[2]
		x4_out = xout[3]
		x1_last = x1_out
		x2_last = x2_out
		x3_last = x3_out
		x4_last = x4_out
		u1_last = u1_cur
	
	REX.y0.v = x1_out
	REX.y1.v = x2_out
	REX.y2.v = x3_out
	REX.y3.v = x4_out
	return 0 
